unit GListU;

interface

uses
  SharedObjectU;

type
  generic TGList<T> = class
    // also tried:
    // generic TGList<T> = class refcounted
    // generic TGList<T> = class(TSharedObject) // TSharedObject is declared in SharedObjectU
  public
    type TDynArray = array of T;
  protected
    ItemsF: TDynArray;
    CountF: Integer;
  public
    property Count: Integer read CountF;
  end;

  TCustomObjectList = specialize TGList<TObject>;

  TObjectList = class {$ifDef production}refcounted{$endif}(TCustomObjectList);

implementation

end.

